apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
    backups-opsperator: k8s-backups
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ backups_name }}
  name: {{ backups_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ backups_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ backups_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ backups_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      containers:
      - env:
        - name: BACKUP_INTERVAL
          value: "{{ backups_job_interval }}"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DROP_FAULTY_BACKUPS
          value: "{{ 'true' if (backups_prune_faulty | default(True)) else 'false' }}"
{% if do_s3 %}
{% if backups_s3_flavor == 'minio' %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name }}-backups
        - name: S3_EXPORT_METHOD
          value: {{ backups_s3_export_method }}
        - name: S3_REMOTE_ADDRESS
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_REMOTE_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name }}-backups
        - name: S3_REMOTE_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_REMOTE_PROTO
          value: {{ minio_api_address | urlsplit('scheme') }}
        - name: S3_REMOTE_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name }}-backups
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name }}-backups
{% elif backups_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name }}-backups
        - name: S3_EXPORT_METHOD
          value: {{ backups_s3_export_method }}
        - name: S3_REMOTE_ADDRESS
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_REMOTE_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name }}-backups
        - name: S3_REMOTE_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_REMOTE_PROTO
          value: {{ radosgw_api_address | urlsplit('scheme') }}
        - name: S3_REMOTE_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ rgw_name }}-backups
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name }}-backups
{% endif %}
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: WATCH_NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        - name: WATCH_OBJECTS
{% if k8s_flavor == 'kubernetes' %}
          value: deployments,statefulsets,daemonsets
{% else %}
          value: deployments,deploymentconfigs,statefulsets,daemonsets
{% endif %}
{% if do_triggers == False or (opsimages | json_query("[?name=='backups'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='backups'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: backups
        resources:
          limits:
            cpu: "{{ backups_cpu_limit }}"
            memory: "{{ backups_memory_limit }}"
          requests:
            cpu: "{{ backups_cpu_limit }}"
            memory: "{{ backups_memory_limit }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /backups
          name: data
{% if do_exporters %}
      - env:
        - name: BACKUPS_ROOT
          value: /backups
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='backupsexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='backupsexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
{% endif %}
        volumeMounts:
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      serviceAccountName: {{ backups_name }}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ backups_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='backups'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - backups
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='backups'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='backupsexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='backupsexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
